USES
  Crt, Objects, GScreen, GStrn, GList, GKeybord, GWindows;

TYPE
  String80 = STRING[80];
  PCrack = ^TCrack;
  TCrack = OBJECT(TObject)
    Name: PString;
    Data: ARRAY [1..20] OF PString;
    Counter: Byte;
    CONSTRUCTOR Init( NewName: STRING;
                      NewData: ARRAY OF String80;
                      NewCounter: Byte);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PCrackCollection = ^TCrackCollection;
  TCrackCollection = OBJECT( TSortedCollection )
    FUNCTION KeyOf( Item: Pointer ) : Pointer; VIRTUAL;
    FUNCTION Compare( Key1, Key2: Pointer ) : Integer; VIRTUAL;
  END;

VAR
  Database: PCrackCollection;
  TheCrack: PCrack;
  ListW   : PList;
  I       : Integer;

FUNCTION TCrackCollection.KeyOf(Item: Pointer): Pointer;
BEGIN
  KeyOf := @PCrack(Item)^.Name;
END;

FUNCTION TCrackCollection.Compare(Key1, Key2: Pointer): Integer;
BEGIN
  IF PString( Key1^ )^ = PString( Key2^ )^
    THEN Compare := 0
    ELSE IF PString( Key1^ )^ < PString( Key2^ )^
      THEN Compare := -1
      ELSE Compare := 1;
END;

PROCEDURE TheEnd;
BEGIN
  RmWin; ClrScr;
  DoneList(ListW);
  Dispose(Database, Done);
  Cursor(On);
  TextColor(14);
  Write('Bye. . . . for now!');
  Halt(0);
END;

CONSTRUCTOR TCrack.Init( NewName: STRING;
                         NewData: ARRAY OF String80;
                         NewCounter: Byte);
BEGIN
  Name := NewStr( NewName );
  Counter := NewCounter;
  FOR I := 0 TO NewCounter DO Data[I+1] := NewStr( NewData[I] );
END;

DESTRUCTOR TCrack.Done;
BEGIN
  DisposeStr( Name );
  FOR I := 1 TO Counter + 1 DO DisposeStr( Data[i] );
END;

PROCEDURE GetCracks;
VAR
  DataFile: Text;
  NName: STRING;
  NData: ARRAY[1..20] OF String80;
  NCount: Byte;

  PROCEDURE GetCrk;
  BEGIN
    REPEAT
      Readln(DataFile, NData[NCount]);
      IF NData[NCount] = '-=-' THEN
      BEGIN
        Dec( NCount );
        Exit;
      END;
      Inc( NCount );
    UNTIL Eof( DataFile );
  END;

BEGIN
  Assign(DataFile, 'CORECT.###');
  {$I-}
   Reset(DataFile);
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    Writeln;
    Writeln('Can''t find CORECT.###');
    Halt(2);
  END;
  Database := New(PCrackCollection, Init(1, 1));
  REPEAT
    NName  := '';
    NCount := 1;
    FillChar(NData,1620,0);
    Readln(DataFile, NName);
    GetCrk;
    Database^.Insert(New(PCrack, Init(NName,NData,NCount)));
  UNTIL Eof(DataFile);
  Close(DataFile);
END;

PROCEDURE ShowCrack(Position: Integer);
VAR
  F: Byte;
  SLine: STRING;

  PROCEDURE FormatLine;
  CONST
    Search : STRING[14] = 'Search for  : ';
    Replace: STRING[14] = 'Replace with: ';
    SStr   : STRING[1] = '$';
    RStr   : STRING[1] = '^';

  VAR FI: Byte;

  BEGIN
    IF SLine[1] = '&' THEN SLine := '';
    FOR FI := 1 TO 2 DO
    BEGIN
      IF Pos(SStr, Sline) <> 0 THEN
      BEGIN
        Insert( Search, Sline, Pos(SStr, Sline));
        Delete( Sline, Pos(SStr, Sline), 1);
      END;
      IF Pos(RStr, Sline) <> 0 THEN
      BEGIN
        Insert( Replace, Sline, Pos(RStr, Sline));
        Delete( Sline, Pos(RStr, Sline), 1);
      END;
    END;
  END;

BEGIN
  TheCrack := Database^.At(Position-1);
  MkWin(2, 3, 77, 21, White, 5, False, Single, ' This is the crack ');
  Dec( TextAttr );
  WITH TheCrack^ DO
  BEGIN
    Writeln;
    Writeln(PadCenter(Name^,75,' '));
    Writeln;
    FOR F := 1 TO Counter DO
    BEGIN
      IF F = 2 THEN Writeln;
      IF Data[F]^[1] = ' ' THEN Writeln;
      Sline := Data[F]^;
      FormatLine;
      Writeln(PadCenter(SLine,75,' '));
      IF Data[F]^[1] = ' ' THEN Writeln;
    END;
    Pause;
    RmWin;
  END;
END;

PROCEDURE Search(Key:Word);
VAR Yes: Boolean;
BEGIN
  Yes := False;
  IF Key IN [97..122] THEN Dec(Key,32);
  FOR I:=0 TO Database^.Count-1 DO
  BEGIN
    TheCrack := Database^.At(I);
    IF Key = Ord(TheCrack^.Name^[1]) THEN
    BEGIN
      Yes := True;
      Break;
    END;
  END;
  IF (I+1 <> ListW^.Position) AND Yes THEN
  BEGIN
    ListW^.Position := I+1;
    ReDrawList(ListW);
  END;
END;

{$F+}
PROCEDURE HookListKeys(Position:Integer; VAR Key:Word);
BEGIN
  CASE Key OF
    33..126: Search(Key);
    kbEnter: ShowCrack(Position);
      kbEsc: ListW^.EndOfList := True;
  END;
END;

FUNCTION GetGameName(Position: Integer):STRING;
BEGIN
  TheCrack := Database^.At(Position-1);
  GetGameName := PadCenter(TheCrack^.Name^,78,' ');
END;
{$F-}

PROCEDURE Initialize;
VAR UsedMemo: Longint;
BEGIN
  TextMode(CO80);
  CheckBreak := False;
  UsedMemo   := MemAvail;
  GetCracks;
  Cursor(Off);
  Dec(UsedMemo, MemAvail);
  WriteBetween(1,80,1,14,0,'SUPER CORECTOR (Internal use only)');
  GotoXY(1, 25);
  FastWrite(8,25,14,'Free Memory - '+Convert(Memavail));
  FastWrite(33,25,14,'Used Memory - '+Convert(UsedMemo));
  FastWrite(58,25,14,'Total Games - '+Convert(Database^.Count));
  InitList(ListW);
  WITH ListW^ DO
  BEGIN
    XPos      := 2;
    YPos      := 3;
    Lines     := 21;
    MaxLines  := Lines;
    BarSize   := 78;
    CanSelect := False;
    MaxTopics := Database^.Count;
    GetString := GetGameName;
    CheckKey  := HookListKeys;
    ListPallete[lBarAttr] := Attr(7,0);
  END;
  MkWin(1, 2, 79, 22, White, Blue, False, Double, '[ Select cracked game ]');
END;

BEGIN
  Initialize;
  ShowList(ListW);
  TheEnd;
END.